#include <vector>
#include <cstring>
#include <fstream>
#include <Windows.h>
using namespace std;

#define SIZEN 35
typedef pair<short, short> coord;

#pragma comment(lib, "winmm.lib")

int N;
char A[SIZEN][SIZEN], C[SIZEN][SIZEN];		//c - reserven variant
short Num[SIZEN][SIZEN]; 

int i, j, t;

vector<coord> myTurn;

//bool koftiCase;

int startTime = timeGetTime();

struct Cell
{
	coord c;
	short value;

	Cell(short value = -1, coord c = coord(-1, -1))
	{
		this->value = value;
		this->c.first = c.first;
		this->c.second = c.second;
	}
	
} biggest;

void ReadInputData();
void FindTheBiggestNumber();
void MakeMyTurn();
void Output();

void PrintTable();
//time_t startTime, endTime;

int main()
{
	ReadInputData();
	//PrintTable();
	//return 1;
	
	MakeMyTurn();
	Output();

	return 0;
}

void ReadInputData()
{
	fstream cin;
	cin.open("game.in", ios::in);
	char str[128];
	cin >> N;	
	
	int numBs = 0;

	for(i = N+4; i > 0; i--)
		memset(A[i], '-', N+4);

	cin.getline(str, 128);

	for(i = 2; i < N + 2; i++)						
	{
		cin.getline(str, 128);

		for(short currPos = 0, j = 2; j < N + 2; j++)
		{
			if('0' <= str[currPos] && str[currPos] <= '9')
			{
				A[i][j] = 'N';
				C[i][j] = 'N';
				if('0' <= str[currPos+1] && str[currPos+1] <= '9')
				{
					Num[i][j] = (str[currPos] - '0')*10 + (str[currPos+1] - '0');
					currPos += 3;
				}
				else
				{
					Num[i][j] = str[currPos] - '0';
					currPos+=2;
				}		
			}
			else
			{
				A[i][j] = str[currPos];
				C[i][j] = str[currPos];
				currPos +=2;
			}
		}
	}
	cin.close();
}

void PrintTable()
{
	fstream cout;
	cout.open("game.out", ios::out);
	cout << endl;
	for(i = 2; i < N+2; i++)
	{
		for(int j = 2; j < N+2; j++)
			if(A[i][j] != 'N') cout << A[i][j] << " ";
			else cout << Num[i][j] << " ";
		cout << endl;
	}
	cout.close();
}

void Output()
{
	fstream cout;
	cout.open("game.out", ios::out);
	cout << myTurn.size() << endl;
	for(i = myTurn.size() - 1; i >= 0; i--)
		cout << myTurn[i].first - 2 << " " << myTurn[i].second - 2 << endl;	


	cout.close();
}


inline bool isReached(const coord &c)
{
	return (A[c.first + 1][c.second] == 'A') || 
		(A[c.first - 1][c.second] == 'A') || 
		(A[c.first][c.second + 1] == 'A') || 
		(A[c.first][c.second - 1] == 'A') ||
		(A[c.first + 1][c.second] == 'B') || 
		(A[c.first - 1][c.second] == 'B') || 
		(A[c.first][c.second + 1] == 'B') || 
		(A[c.first][c.second - 1] == 'B');
}

void FindTheBiggestNumber()
{
	for(i = 2; i < N + 2; i++)
	{
		for(j = 2; j < N + 2; j++)
			if(A[i][j]=='N' && 
				Num[i][j] > biggest.value && 
				!isReached(coord(i, j)) && 
				!(i == biggest.c.first && j != biggest.c.second))
			{
				biggest.value = Num[i][j];
				biggest.c.first = i;
				biggest.c.second = j;
			}
	}
}

coord GetNextCell(coord currCell);

void MakeMyTurn()
{
	bool restart = false;
	do
	{
	FindTheBiggestNumber();
		A[biggest.c.first][biggest.c.second] = 'A';
		myTurn.clear();
		myTurn.reserve(biggest.value);
		myTurn.push_back(biggest.c);
		for(i = 1; i < biggest.value; i++)
		{
			coord nextCell;

			for(j = myTurn.size()-1; j >= 0; j--)
			{
				nextCell = GetNextCell(myTurn[j]);

				if(!((nextCell.first == (-1)) && nextCell.second == (-1)))
					break;
			}

			if(!((nextCell.first == (-1)) && nextCell.second == (-1)))
			{
				A[nextCell.first][nextCell.second] = 'A';
				myTurn.push_back(nextCell);
			}
			else
			{
				restart = true;
				for(int i = 0; i < N; i++)
					for(int j = 0; j <N; j++)
						A[i][j] = C[i][j];
				break;
			}
		}
	}while(restart);
}

inline short minDistToNumber(const coord &c)
{
	char C[SIZEN][SIZEN];
	for(int i = N+4; i > 0; i--)
		memset(C[i], true, sizeof(bool)*SIZEN);

	vector<coord> v;
	v.reserve(N*N);
	v.push_back(c);
	C[c.first][c.second] = false;

	short levelStart, levelEnd, level;
	level = 0;
	levelStart = 0;
	levelEnd = 1;
			
	while(levelStart < v.size())
	{
		for(int h = levelStart; h < levelEnd; h++)
		{
			if(A[v[h].first][v[h].second] == 'N' && !isReached(v[h]))
			{
				return level;
			}

			//up
			if(v[h].first > 2 &&										//if exist
				A[v[h].first - 1][v[h].second] != 'A' &&					//if is not occupied
				A[v[h].first - 1][v[h].second] != 'B' &&					//if is not occupied
				C[v[h].first - 1][v[h].second])							//if is available
			{
				C[v[h].first - 1][v[h].second] = false;
				v.push_back(coord(v[h].first - 1, v[h].second));
			}

			//down
			if(v[h].first < N+1 &&										//if exist
				A[v[h].first + 1][v[h].second] != 'A' &&				//if is not occupied
				A[v[h].first + 1][v[h].second] != 'B' &&				//if is not occupied
				C[v[h].first + 1][v[h].second])							//if is available
			{
				C[v[h].first + 1][v[h].second] = false;
				v.push_back(coord(v[h].first + 1, v[h].second));
			}

			//left
			if(v[h].second > 2 &&										//if exist
				A[v[h].first][v[h].second - 1] != 'A' &&					//if is not occupied
				A[v[h].first][v[h].second - 1] != 'B' &&					//if is not occupied
				C[v[h].first][v[h].second - 1])							//if is available
			{
				C[v[h].first][v[h].second - 1] = false;
				v.push_back(coord(v[h].first, v[h].second - 1));
			}

			//right
			if(v[h].second < N+1 &&										//if exist
				A[v[h].first][v[h].second + 1] != 'A' &&				//if is not occupied
				A[v[h].first][v[h].second + 1] != 'B' &&				//if is not occupied
				C[v[h].first][v[h].second + 1])							//if is available
			{
				C[v[h].first][v[h].second + 1] = false;
				v.push_back(coord(v[h].first, v[h].second + 1));
			}
		}
		levelStart = levelEnd;
		levelEnd = v.size();
		level++;
	}
	return level;
}

coord GetNextCell(coord currCell)
{
	/* possibleMoves
		  0 
		3 c 1
		  2  
	*/
	bool possibleMoves[4];		
	for(t = 0; t < 4; t++) possibleMoves[t] = true;
									
	//Check if the currCell is at edge of the table------------
	if(currCell.first == 2) possibleMoves[0] = false;
	else if(currCell.first == N+1) possibleMoves[2] = false;
	if(currCell.second == N+1) possibleMoves[1] = false;
	else if(currCell.second == 2) possibleMoves[3] = false;
	//----------------------------------------------------------

	//Check for already painted cells---------------------------
	if(A[currCell.first-1][currCell.second] == 'A')
		possibleMoves[0] = false;
	if(A[currCell.first][currCell.second+1] == 'A')
		possibleMoves[1] = false;
	if(A[currCell.first+1][currCell.second] == 'A')
		possibleMoves[2] = false;
	if(A[currCell.first][currCell.second-1] == 'A')
		possibleMoves[3] = false;
	//-----------------------------------------------------------

	// Look for enemy cells--------------------------------------
	if(A[currCell.first-1][currCell.second-1] == 'B')
	{
		possibleMoves[0] = false;
		possibleMoves[3] = false;
	}
	if(A[currCell.first-1][currCell.second+1] == 'B')
	{
		possibleMoves[0] = false;
		possibleMoves[1] = false;
	}
	if(A[currCell.first+1][currCell.second+1] == 'B')
	{
		possibleMoves[1] = false;
		possibleMoves[2] = false;
	}
	if(A[currCell.first+1][currCell.second-1] == 'B')
	{
		possibleMoves[2] = false;
		possibleMoves[3] = false;
	}
	if(A[currCell.first - 2][currCell.second] == 'B')
		possibleMoves[0] = false;
	if(A[currCell.first][currCell.second + 2] == 'B')
		possibleMoves[1] = false;
	if(A[currCell.first + 2][currCell.second] == 'B')
		possibleMoves[2] = false;
	if(A[currCell.first][currCell.second-2] == 'B')
		possibleMoves[3] = false;
	//------------------------------------------------------------
	
	//Check for number in the avalable cells----------------------
	if(A[currCell.first-1][currCell.second] == 'N')
		possibleMoves[0] = false;
	if(A[currCell.first][currCell.second + 1] == 'N')
		possibleMoves[1] = false;
	if(A[currCell.first + 1][currCell.second] == 'N')
		possibleMoves[2] = false;
	if(A[currCell.first][currCell.second - 1] == 'N')
		possibleMoves[3] = false;
	//------------------------------------------------------------


	//Look for cell with not ocupied number in the edges---------------------------------------------------------------------------------------------		
	if(A[currCell.first-1][currCell.second-1] == 'N' && 
		!isReached(coord(currCell.first-1, currCell.second-1)))							
	{ 
		if(possibleMoves[0] && !possibleMoves[3]) return coord(currCell.first-1, currCell.second);
		if(possibleMoves[3] && !possibleMoves[0]) return coord(currCell.first, currCell.second-1);
		if(possibleMoves[0] && possibleMoves[3])								// TODO: Optimization: just one condition
		{
			A[currCell.first-1][currCell.second-1] = 'M'; 			//Mask the number so it will be unvisible for minDistToNumber func
			
			//if(koftiCase) //
			if(true) // if(timeGetTime() - startTime > 200)
			{
					int dist0 = minDistToNumber(coord(currCell.first-1, currCell.second));
					int dist3 = minDistToNumber(coord(currCell.first, currCell.second-1));

					A[currCell.first-1][currCell.second-1] = 'N'; 			//Umask the number

					if(dist0 < dist3)
						return coord(currCell.first-1, currCell.second);
					else
						return coord(currCell.first, currCell.second-1);
			}
			else return coord(currCell.first-1, currCell.second);
		}
	}
	if(A[currCell.first-1][currCell.second+1] == 'N' && 
		!isReached(coord(currCell.first-1, currCell.second+1)))
	{
		if(possibleMoves[0] && !possibleMoves[1]) return coord(currCell.first-1, currCell.second);
		if(possibleMoves[1] && !possibleMoves[0]) return coord(currCell.first, currCell.second+1);
		if(possibleMoves[0] && possibleMoves[1])
		{
			//if(koftiCase) //
			if(true) // if(timeGetTime() - startTime > 200)
			{
				A[currCell.first-1][currCell.second+1] = 'M';			//Mask the number so it will be unvisible for minDistToNumber func

				int dist0 = minDistToNumber(coord(currCell.first-1, currCell.second));
				int dist1 = minDistToNumber(coord(currCell.first, currCell.second+1));

				A[currCell.first-1][currCell.second+1] = 'N';			//Umask the number
			
				if(dist0 < dist1)
					return coord(currCell.first-1, currCell.second);
				else
					return coord(currCell.first, currCell.second+1);
			}
			else return coord(currCell.first-1, currCell.second);
		}
	}
	if(A[currCell.first+1][currCell.second+1] == 'N' && 
		!isReached(coord(currCell.first+1, currCell.second+1)))
	{
		if(possibleMoves[2] && !possibleMoves[1]) return coord(currCell.first+1, currCell.second);
		if(possibleMoves[1] && !possibleMoves[2]) return coord(currCell.first, currCell.second+1);
		if(possibleMoves[1] && possibleMoves[2])
		{
			//if(koftiCase) //
			if(true) // if(timeGetTime() - startTime > 200)
			{
				A[currCell.first+1][currCell.second+1] = 'M';			//Mask the number so it will be unvisible for minDistToNumber func

				int dist1 = minDistToNumber(coord(currCell.first, currCell.second+1));
				int dist2 = minDistToNumber(coord(currCell.first+1, currCell.second));

				A[currCell.first+1][currCell.second+1] = 'N';			//Umask the number
			
				if(dist1 < dist2)
					return coord(currCell.first, currCell.second+1);
				else 
					return coord(currCell.first+1, currCell.second);
			}
			else return coord(currCell.first, currCell.second+1);
		}
	}
	
	if(A[currCell.first+1][currCell.second-1] == 'N' && 
		!isReached(coord(currCell.first+1, currCell.second-1)))
	{
		if(possibleMoves[2] && !possibleMoves[3]) return coord(currCell.first+1, currCell.second);
		if(possibleMoves[3] && !possibleMoves[2]) return coord(currCell.first, currCell.second-1);
		if(possibleMoves[2] && possibleMoves[3])
		{
			//if(koftiCase) //
			if(true) // if(timeGetTime() - startTime > 200)
			{
				A[currCell.first+1][currCell.second-1] = 'M';			//Mask the number so it will be unvisible for minDistToNumber func
			
				int dist2 = minDistToNumber(coord(currCell.first+1, currCell.second));
				int dist3 = minDistToNumber(coord(currCell.first, currCell.second-1));

				A[currCell.first+1][currCell.second-1] = 'N';			//Umask the number

				if(dist2 < dist3)
					return coord(currCell.first+1, currCell.second);
				else 
					return coord(currCell.first, currCell.second-1); 
			}
			else return coord(currCell.first+1, currCell.second);
		}
	}
	//-----------------------------------------------------------------------------------------------------------------------------------------------------
	
	
	//else paint the available cell with the smallest distance with number---------------------------------------------------------------------------------
	
	//if(koftiCase) //
	if(true) // if(timeGetTime() - startTime < 400)
	{
		short minDistToNums[4];

		if(possibleMoves[0]) minDistToNums[0] = minDistToNumber(coord(currCell.first-1, currCell.second));
		if(possibleMoves[1]) minDistToNums[1] = minDistToNumber(coord(currCell.first, currCell.second+1));
		if(possibleMoves[2]) minDistToNums[2] = minDistToNumber(coord(currCell.first+1, currCell.second));
		if(possibleMoves[3]) minDistToNums[3] = minDistToNumber(coord(currCell.first, currCell.second-1));

		short bestMoveIndex = -1,
			bestMoveDistToNum = 15000;

		for(int h = 0; h < 4; h++)
			if(possibleMoves[h] && minDistToNums[h] < bestMoveDistToNum)
			{
				bestMoveDistToNum = minDistToNums[h];
				bestMoveIndex = h;
			}

		switch(bestMoveIndex)
		{
			case 0: return coord(currCell.first-1, currCell.second);
			case 1: return coord(currCell.first, currCell.second+1);
			case 2: return coord(currCell.first+1, currCell.second);
			case 3: return coord(currCell.first, currCell.second-1);
			default: return coord(-1, -1);
		}
	}
	else
	{
		if(possibleMoves[0]) return coord(currCell.first-1, currCell.second);
		if(possibleMoves[1]) return coord(currCell.first, currCell.second+1);
		if(possibleMoves[2]) return coord(currCell.first+1, currCell.second);
		if(possibleMoves[3]) return coord(currCell.first, currCell.second-1);
		return coord(-1, -1);
	}
}
